const char WIFI_SSID[] = "Vojta";
const char WIFI_PASSWORD[] = "36471Liliki";
String HOST_NAME = "http://dp.sebesta.fun/subdom/dp/";
String name = "";
int stock = 0;

/* -- fce pro knihovnu -- */
int readFromDB(String PATH_NAME, String queryString, String &payload) {
  // funkce, která se připojí na server a získá odpověď
  
  HTTPClient http;

  http.begin(HOST_NAME + PATH_NAME + queryString);  //HTTP
  int httpCode = http.GET();

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      payload = http.getString();   
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
      return httpCode;
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
  return 1;
}

void insertToDB(String input, String type) {

  Serial.println("Posting JSON data to server...");
  HTTPClient http;

  http.begin("http://dp.sebesta.fun/subdom/dp/insert_book.php");  //HTTP
  http.addHeader("Content-Type", "application/json");

  StaticJsonDocument<200> doc;    // Add values in the document
  
  doc[type] = input;

  String requestBody;
  serializeJson(doc, requestBody);
     
  int httpCode = http.POST(requestBody);

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      String payload = http.getString();
      Serial.println(payload);
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
}

void updateDB(String input, String count, String type) {

  Serial.println("Posting JSON data to server...");
  HTTPClient http;

  http.begin("http://dp.sebesta.fun/subdom/dp/update_book.php");  //HTTP
  http.addHeader("Content-Type", "application/json");

  StaticJsonDocument<200> doc;    // Add values in the document
  
  doc[type] = input;
  doc["count"] = count;

  String requestBody;
  serializeJson(doc, requestBody);
  Serial.println(requestBody);
  int httpCode = http.POST(requestBody);

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      String payload = http.getString();
      Serial.println(payload);
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
}

void addQR(String value, String count) {
  //Serial.println(value);
  String type = "code"; 
  updateDB(value, count, type); 
}

void addRFID(String value, String count) {
  //Serial.println(value);
  String type = "rfid"; 
  updateDB(value, count, type); 
}

void getID(String value) {
  // funkce, která volá předchozí readFromDB() a zpracovává JSON
  // jako vstupní parametr přijímá ID knihy, předané volající funkcí
  // výsledek zpracování je uložen do globálních proměnných name a stock
  String a = "get_book.php";    // cesta k PHP skriptu
  String b = "?id=" + value;    // parametr pro PHP skript
  String result = "";           // proměnná pro uložení odpovědi
  readFromDB(a, b, result);     // volání funkce readFromDB()

  StaticJsonDocument<200> doc;  // vytvoření objektu pro zpracování JSON
  const char* json = result.c_str();    // převedení odpovědi na char*
  DeserializationError error = deserializeJson(doc, json);  // zpracování JSON
  if (error) {  // pokud dojde k chybě, vypíšeme ji na sériovou linku
    Serial.print(F("deserializeJson() failed: "));
    Serial.println(error.f_str());
    return;
  }
  String title = doc["title"];  // získání názvu knihy z JSON
  int on_stock = doc["on_stock"];   // získání počtu kusů na skladě z JSON
  name = title; // uložení názvu knihy do globální proměnné
  stock = on_stock; // uložení počtu kusů na skladě do globální proměnné
  result = "";  // vynulování proměnné pro uložení odpovědi
  Serial.println(title);
  Serial.println(on_stock);
}

void postQR(String value) {
  //Serial.println(value);
  String type = "code"; 
  insertToDB(value, type); 
}

void postRFID(String value) {
  //Serial.println(val);
  String type = "rfid"; 
  insertToDB(value, type); 
}

// funkce pro hledání kódu na základě id z qr kódu
int getQR(String value) {
  String a = "qr_look_for_book.php";
  String b = "?code=" + value;
  String result = "";
  while (!readFromDB(a, b, result)) {}
  if (result == "false") return 1;
  else {
    StaticJsonDocument<200> doc;
    const char* json = result.c_str();
    DeserializationError error = deserializeJson(doc, json);
    if (error) {
      Serial.print(F("deserializeJson() failed: "));
    }
    String id = doc["id"];
    //Serial.println(id);
    getID(id);
  }
  
  result = "";
  return 0;
}

int getRFID(String value) {  
  String a = "rfid_look_for_book.php";
  String b = "?rfid=" + value;
  //Serial.println(b);
  String result = "";
  while (!readFromDB(a, b, result)) {}
  Serial.println(result);
  if (result == "false") return 1;
  else {
    StaticJsonDocument<200> doc;
    const char* json = result.c_str();
    DeserializationError error = deserializeJson(doc, json);
    if (error) {
      Serial.print(F("deserializeJson() failed: "));
    }
    String id = doc["id"];
    //Serial.println(id);
    getID(id);
  }

  result = "";
  return 0;
}

/* -- fce pro dilnu -- */
int WreadFromDB(String PATH_NAME, String queryString, String &payload) {
  
  String tmp = HOST_NAME + PATH_NAME + queryString;
  //Serial.println(tmp);
  HTTPClient http;

  http.begin(HOST_NAME + PATH_NAME + queryString);  //HTTP
  int httpCode = http.GET();
  //Serial.println(httpCode);

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      payload = http.getString();
      //Serial.println("radek 22");
      //Serial.println(payload);      
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
      return httpCode;
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
  return 1;
}

void WinsertToDB(String input, String type) {

  Serial.println("Posting JSON data to server...");
  HTTPClient http;

  http.begin("http://dp.sebesta.fun/subdom/dp/insert_workshop.php");  //HTTP
  http.addHeader("Content-Type", "application/json");

  StaticJsonDocument<200> doc;    // Add values in the document
  
  doc[type] = input;

  String requestBody;
  serializeJson(doc, requestBody);
     
  int httpCode = http.POST(requestBody);

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      String payload = http.getString();
      Serial.println(payload);
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
}

void WupdateDB(String input, String count, String type) {

  Serial.println("Posting JSON data to server...");
  HTTPClient http;

  http.begin("http://dp.sebesta.fun/subdom/dp/update_workshop.php");  //HTTP
  http.addHeader("Content-Type", "application/json");

  StaticJsonDocument<200> doc;    // Add values in the document
  
  doc[type] = input;
  doc["count"] = count;

  String requestBody;
  serializeJson(doc, requestBody);
  Serial.println(requestBody);
  int httpCode = http.POST(requestBody);

  // httpCode will be negative on error
  if (httpCode > 0) {
    // file found at server
    if (httpCode == HTTP_CODE_OK) {
      String payload = http.getString();
      Serial.println(payload);
    } else {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }

  http.end();
}

void WaddQR(String value, String count) {
  //Serial.println(value);
  String type = "code"; 
  WupdateDB(value, count, type); 
}

void WaddRFID(String value, String count) {
  //Serial.println(value);
  String type = "rfid"; 
  WupdateDB(value, count, type); 
}

void WgetID(String value) {
  //Serial.println(value);
  String a = "get_workshop.php";
  String b = "?id=" + value;
  //Serial.println(b);
  String result = "";
  WreadFromDB(a, b, result);
  //Serial.println(result);

  StaticJsonDocument<200> doc;
  const char* json = result.c_str();
  DeserializationError error = deserializeJson(doc, json);
  if (error) {
    Serial.print(F("deserializeJson() failed: "));
    Serial.println(error.f_str());
    return;
  }
  String title = doc["name"];
  int on_stock = doc["on_stock"];
  name = title;
  stock = on_stock;
  Serial.println(title);
  Serial.println(on_stock);

  result = "";
}

void WpostQR(String value) {
  //Serial.println(value);
  String type = "code"; 
  WinsertToDB(value, type); 
}

void WpostRFID(String value) {
  //Serial.println(val);
  String type = "rfid"; 
  WinsertToDB(value, type); 
}

int WgetQR(String value) {
  String a = "qr_look_for_workshop.php";
  String b = "?code=" + value;
  //Serial.println(b);
  String result = "";
  while (!WreadFromDB(a, b, result)) {}
  Serial.println(result);
  if (result == "false") return 1;
  else {
    StaticJsonDocument<200> doc;
    const char* json = result.c_str();
    DeserializationError error = deserializeJson(doc, json);
    if (error) {
      Serial.print(F("deserializeJson() failed: "));
    }
    String id = doc["id"];
    //Serial.println(id);
    WgetID(id);
  }
  
  result = "";
  return 0;
}

int WgetRFID(String value) {  
  String a = "rfid_look_for_workshop.php";
  String b = "?rfid=" + value;
  //Serial.println(b);
  String result = "";
  while (!WreadFromDB(a, b, result)) {}
  Serial.println(result);
  if (result == "false") return 1;
  else {
    StaticJsonDocument<200> doc;
    const char* json = result.c_str();
    DeserializationError error = deserializeJson(doc, json);
    if (error) {
      Serial.print(F("deserializeJson() failed: "));
    }
    String id = doc["id"];
    //Serial.println(id);
    WgetID(id);
  }

  result = "";
  return 0;
}