<?php
error_reporting(E_ALL);

if(!ob_start('ob_gzhandler'))
    ob_start();

header('Content-Type: text/html; charset=utf-8');

include('lazy_mofo.php');

echo "
<!DOCTYPE html>
<html lang='cs'>
<head>
	<meta charset='UTF-8'>
	<link rel='stylesheet' type='text/css' href='style.css'>
    	<meta name='robots' content='noindex,nofollow'>
	<title>Knihovna</title>
</head>
<body>
<a style='float: right' href='.'>Domů</a>
";

$db_host = "md336.wedos.net";
$db_name = "d300531_dp";
$db_username = "w300531_dp";
$db_password = "SdgH5WxS";

// connect to database with pdo
$dbh = new PDO("mysql:host=$db_host;dbname=$db_name;", $db_username, $db_password);

// create LM object, pass in PDO connection, see i18n folder for language + country options
$lm = new lazy_mofo($dbh, 'cz-cs');

$lm->form_input_control['isbn'] = array('type' => 'number');
$lm->form_input_control['published_date'] = array('type' => 'dateY');

// show search box, but _search parameter still needs to be passed to query below
$lm->grid_show_search_box = true;

// query to define grid view
// IMPORTANT - last column must be the identity/key for [edit] and [delete] links to appear
// include an 'order by' to prevent potential parsing issues
$lm->grid_sql = "
SELECT
	`id`,
	`code`,
	`rfid`,
	`title`,
	`author`,
	`isbn`,
	`on_stock`,
	`published_date`,
	`created_at`,
	`updated_at`,
	`id`
FROM  books 
WHERE COALESCE(`title`, '') LIKE :_search 
or    COALESCE(`author`, '') LIKE :_search 
or    COALESCE(`isbn`, '') LIKE :_search 
ORDER BY `id` ASC
";


$_search = "%";
if(isset($_REQUEST['_search']))
    $_search = "%" . trim($_REQUEST['_search']) . "%";


// bind parameter for grid query
$lm->grid_sql_param[':_search'] = $_search;

// table name for updates, inserts and deletes
$lm->table = 'books';

$lm->form_sql = "
SELECT
	`id`
,	`code`
,	`rfid`
,	`title`
,	`author`
,	`isbn`
,	`published_date`
,	`on_stock`
,	`notes`
FROM  `books`
WHERE `id` = :id
";

$lm->rename['id'] = 'ID';
$lm->rename['code'] = 'Kód';
$lm->rename['rfid'] = 'RFID';
$lm->rename['title'] = 'Název';
$lm->rename['author'] = 'Autor';
$lm->rename['isbn'] = 'ISBN';
$lm->rename['on_stock'] = 'Skladem kusů';
$lm->rename['published_date'] = 'Rok vydání';
$lm->rename['created_at'] = 'Záznam vytvořen';
$lm->rename['updated_at'] = 'Záznam aktualizován';
$lm->rename['notes'] = 'Poznámky';

$id = 0;
if(isset($_REQUEST['id']))
    $id = $_REQUEST['id'];

// bind parameter for form query
$lm->form_sql_param[':id'] = @$_REQUEST['id'];

// identity / primary key column name
$lm->identity_name = 'id';
$lm->after_update_user_function = 'my_after_update';

$lm->run();
function my_after_update($id)
{
    global $lm;

    $sql_param = array(':id' => $id);
    $sql = "UPDATE books SET updated_at = now() WHERE id = :id";
    $lm->query($sql, $sql_param);

}
echo '</body><footer><div class="footer"><p>Tato webová aplikace je součástí diplomové práce.</p><p>© 2023 - Bc. Vojtěch Šebesta</p><img class="logo" src="pics/CZU_logo_bila.png" alt="logo ČZU" class="logo" /></div></footer></html>';
?>